<?php

function parse_error($msg)
{
    header("Content-Type: text/plain");
    print("error\n");
    print($msg."\n");
}

function parse_success($mtf)
{
    header("Content-Type: text/plain");
    print("URL:".get_option('siteurl'));
    print("/wp-content/plugins/wp-spainter/wp-spainter-redirect.php?$mtf");
}

function parse_data()
{
    $buffer = $_REQUEST['HTTP_RAW_POST_DATA'];
    if(!$buffer){
        $buffer = $HTTP_RAW_POST_DATA;
    }
    if(!$buffer && function_exists('file_get_contents')){
        $buffer = file_get_contents("php://input");
    }
    if(!$buffer){
        $stdin = @fopen("php://input", "rb");
        $buffer = @fread($stdin, $_ENV['CONTENT_LENGTH']);
        @fclose($stdin);
    }
    if(!$buffer){
        parse_error("Content has no data:".$_ENV['CONTENT_LENGTH']);
        return false;
    }

    $hLen = substr($buffer, 1, 8);
    $eHead = substr($buffer, 1 + 8, $hLen);
    $mtf = tempnam($tmpd, "spainter");
    if($mt = fopen($mtf, "w")){
        fwrite($mt, $buffer, strlen($buffer));
        fclose($mt);
        return "f=$mtf&$eHead";
    }

    return false;
}

function temp()
{
    $mtf = parse_data();

    $d = dirname(dirname(dirname(dirname(__FILE__))));
    if(!file_exists("$d/wp-config.php")){
        parse_error("not found wp-config.php file");
        return false;
    }
    require_once("$d/wp-config.php");

    if($mtf){
        parse_success($mtf);
    }
}

{
    do {
        // 関数読み込み
        $d = dirname(dirname(dirname(dirname(__FILE__))));
        if(!file_exists("$d/wp-config.php")){
            parse_error("config not found");
            break;
        }
        require_once("$d/wp-config.php");
        if(!file_exists("$d/wp-admin/includes/file.php")){
            parse_error("file.php read error($d/wp-admin/includes/file.php)");
            break;
        }
        require_once("$d/wp-admin/includes/file.php");
        if(!file_exists("$d/wp-admin/includes/image.php")){
            parse_error("file.php read error($d/wp-admin/includes/image.php)");
            break;
        }
        require_once("$d/wp-admin/includes/image.php");
        if(!file_exists("$d/wp-admin/includes/media.php")){
            parse_error("media.php read error($d/wp-admin/includes/media.php)");
            break;
        }
        require_once("$d/wp-admin/includes/media.php");

        // データ読み込み
        $buffer = $_REQUEST['HTTP_RAW_POST_DATA'];
        if(!$buffer){
            $buffer = $HTTP_RAW_POST_DATA;
        }
        if(!$buffer && function_exists('file_get_contents')){
            $buffer = file_get_contents("php://input");
        }
        if(!$buffer){
            $stdin = @fopen("php://input", "rb");
            $buffer = @fread($stdin, $_ENV['CONTENT_LENGTH']);
            @fclose($stdin);
        }
        if(!$buffer){
            parse_error("Content has no data:".$_ENV['CONTENT_LENGTH']);
            return false;
        }
        $hLen = substr($buffer, 1, 8);
        $eHead = substr($buffer, 1 + 8, $hLen);
        $iLen = substr($buffer, 1 + 8 + $hLen, 8);
        $img = substr($buffer, 1 + 8 + $hLen + 8 + 2, $iLen);
        $ext = (substr($img, 1, 5) == "PNG\r\n")? "png": "jpg";
        $mime = "image/$ext";

        $ha = preg_split("/&/", $eHead);
        foreach($ha as $p){
            $pa = preg_split("/=/", $p);
            $eHeadA[$pa[0]] = $pa[1];
        }
        $title = $eHeadA['title'].".".$ext;

        // 保存ファイル名作成
        if(!(($uploads = wp_upload_dir()) && false === $uploads['error'])){
            parse_error("upload directory not found.");
            break;
        }
        $filename = wp_unique_filename( $uploads['path'], $title, $unique_filename_callback );
        $new_file = $uploads['path'] . "/$filename";

        // データ保存
        $mt = @fopen($new_file, "w");
        @fwrite($mt, $img, $iLen);
        @fclose($mt);
        $stat = stat( dirname( $new_file ));
        $perms = $stat['mode'] & 0000666;
        @ chmod( $new_file, $perms );

        // アップロードフィルタ適応
        $url = $uploads['url'] . "/$filename";
        $file = apply_filters('wp_handle_upload', array('file' => $new_file, 'url' => $url, 'type' => $mime));
        if(isset($file['error'])){
            return new wp_error( 'upload_error', $file['error'] );
            //parse_error($file['error']);
            //break;
        }

        // パラメータ設定
        $url = $file['url'];
        $type = $file['type'];
        $file = $file['file'];
        $title = preg_replace('/\.[^.]+$/', '', basename($file));
        $excerpt = $eHeadA['caption'];
        if($image_meta = wp_read_image_metadata($file)){
            if(trim($image_meta['title'])){
                $title = $image_meta['title'];
            }
            if(trim($image_meta['caption'])){
                $content = $image_meta['caption'];
            }
        }
        $attachment = array(
            'post_mime_type' => $type,
            'guid' => $url,
            'post_parent' => $post_id,
            'post_title' => $title,
            'post_content' => $content,
            'post_excerpt' => $excerpt,
            );

        // パラメータ登録
        $id = wp_insert_attachment($attachment, $file, $post_parent);
        if(!is_wp_error($id)){
            wp_update_attachment_metadata(
                $id,
                wp_generate_attachment_metadata(
                    $id,
                    $file
                    )
                );
        }
    } while(0);
}
?>
