<?php
/*
Plugin Name: WordPress Shi-Painter Plugin
Plugin URI: http://blog.yakumo.la/?page_id=13
Description: Drawing plugin uses Shi-Painter
Author: yakumo
Version: 1.2
Author URI: http://blog.yakumo.la/
*/
/*  Copyright 2008  yakumo  (email : warabi0999__AT__gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function has_shi_painter()
{
    $sp = dirname(__FILE__) . "/spainter.jar";
    return file_exists($sp);
}

function has_dynamic_palette()
{
    $sp = dirname(__FILE__) . "/palette.js";
    return file_exists($sp);
}

function shi_painter_reset_option()
{
    delete_option('shipainter_tooltype');
}

function shi_painter_plugin()
{
    add_action('media_upload_tabs', 'add_media_upload_shi');
    add_action('media_upload_shi_painter', 'media_upload_shi_painter');
    add_action('admin_menu', 'shi_painter_add_admin_menu');
    if(!function_exists('wp_enqueue_style')){
        add_action('admin_head_media_upload_shi_painter_form', 'media_admin_css');
    }
    add_option('shipainter_tooltype', 'smp');
    add_option('shipainter_defwidth', '300');
    add_option('shipainter_defheight', '300');
}
//shi_painter_reset_option();
shi_painter_plugin();

function shi_painter_add_admin_menu()
{
    if(function_exists('add_submenu_page')){
        add_submenu_page('options-general.php',
                         __('Oekaki Shi-Painter'),
                         __('Oekaki Shi-Painter'),
                         'manage_options',
                         'shi-painter-config',
                         'shi_painter_conf');
    }
}

function add_media_upload_shi($tabs)
{
    if(has_shi_painter() &&
       ((array_key_exists('type', $_POST) &&
         $_POST['type'] == 'image') ||
        (array_key_exists('type', $_GET) &&
         $_GET['type'] == 'image'))){
        $tabs = array_merge($tabs, array('shi_painter' => __('Oekaki Shi-Painter')));
    }
    return $tabs;
}

function media_upload_shi_painter()
{
    if(!empty($_GET['sp_mode']) && 'save' == $_GET['sp_mode']){
        parse_data_stream(http_get_request_body_stream());
        return '';
    }
    else if(!empty($_POST['sp_mode'])){
        return wp_iframe('media_upload_shi_painter_form', $errors);
    }
    else if(!empty($_POST)){
        $return = media_upload_form_handler();
        if(is_string($return)){
            return $return;
        }
        if(is_array($return)){
            $errors = $return;
        }
    }
    return wp_iframe('media_upload_shi_painter_form', $errors);
}

function parse_data_stream($s)
{
}

function media_upload_shi_painter_form($errors)
{
    media_upload_header();
    $ise = false;
    if(!empty($_POST['sp_mode'])){
        if('exec' == $_POST['sp_mode']){
            $ise = true;
            media_upload_shi_painter_canvas_form();
        }
    }
    if(!$ise){
        media_upload_shi_painter_exec_form();
    }
}

function media_upload_shi_painter_canvas_form()
{
    update_option('shipainter_defwidth', $_POST['canvas_width']);
    update_option('shipainter_defheight', $_POST['canvas_height']);
    $save_file = "testsave.png";
    $post_id = intval($_REQUEST['post_id']);
    $plugin_url = get_option('siteurl') . "/wp-content/plugins/wp-spainter";
    $form_action_url = "$plugin_url/wp-picpost.php";
    $form_finish_url = get_option('siteurl') . "/wp-admin/media-upload.php?type={$GLOBALS['type']}&tab=library&post_id=$post_id";
    $disp_mode = ($_POST['shipainter_tooltype'] != 'std')? 'normal': 'pro';
    //$exhead = "type=${_POST['type']}&tab=${_POST['tab']}&post_id=${_POST['post_id']}";
    $exhead = "title=${_POST['image_title']}";
    $fTarget = $_POST['frame_id'];

    $sp_width = "100%";
    if(has_dynamic_palette()){
        echo "\n";
        echo '<script type="text/javascript" src="'.$plugin_url.'/palette.js"></script>';
        echo "\n";
        $sp_width = "480";
    }
?>
<script type="text/javascript">
<!--
jQuery(function($){
	var preloaded = $(".media-item.preloaded");
	if ( preloaded.length > 0 ) {
		preloaded.each(function(){prepareMediaItem({id:this.id.replace(/[^0-9]/g, '')},'');});
		updateMediaForm();
	}
});
-->
</script>

<table width="100%"><tr><td width="<?php echo $sp_width; ?>">
<form enctype="multipart/form-data" method="post" action="<?php echo attribute_escape($form_action_url); ?>">
  <applet codebase="<?php echo $plugin_url; ?>" archive="spainter.jar,res/<?php echo $disp_mode; ?>.zip" code="c.ShiPainter.class" name="paintbbs" width="100%" height="450">
   <param name="image_width" value="<?php echo $_POST['canvas_width']; ?>"/>
   <param name="image_height" value="<?php echo $_POST['canvas_height']; ?>"/>
   <param name="dir_resource" value="<?php echo $plugin_url; ?>/res"/>
   <param name="tt.zip" value="<?php echo $plugin_url; ?>/res/tt.zip"/>
   <param name="res.zip" value="<?php echo $plugin_url; ?>/res/res_<?php echo $disp_mode; ?>.zip"/>
   <param name="tools" value="<?php echo $disp_mode; ?>"/>
   <param name="url_save" value="<?php echo $form_action_url; ?>"/>
   <param name="url_exit" value="<?php echo $form_finish_url; ?>"/>
   <param name="url_target" value="<?php echo $fTarget; ?>"/>
   <param name="send_header" value="<?php echo $exhead ?>"/>
   <param name="MAYSCRIPT" value="true"/>
   <param name="mayscript" value="true"/>
   <param name="scriptable" value="true"/>
  </applet>
 <input type="hidden" name="post_id" id="post_id" value="<?php echo $post_id; ?>" />
 <input type="hidden" name="type" value="<?php echo $_POST['type']; ?>" />
 <input type="hidden" name="tab" value="<?php echo $_POST['tab']; ?>" />
</form>
</td><?php if(has_dynamic_palette()){ ?><td>
<script type="text/javascript">
<!--
PaletteInit();
// -->
</script>
</td><?php } ?></tr></table>
<?php
}

function media_upload_shi_painter_exec_form()
{
    $post_id = intval($_REQUEST['post_id']);
    $form_action_url = get_option('siteurl') . "/wp-admin/media-upload.php?type={$GLOBALS['type']}&tab=shi_painter&post_id=$post_id";
?>

<script type="text/javascript">
<!--
jQuery(function($){
	var preloaded = $(".media-item.preloaded");
	if ( preloaded.length > 0 ) {
		preloaded.each(function(){prepareMediaItem({id:this.id.replace(/[^0-9]/g, '')},'');});
		updateMediaForm();
	}
});
-->
</script>

<form method="post" action="<?php echo attribute_escape($form_action_url); ?>">
 <div id="main-form">
  <table class="describe"><tbody>
   <tr>
    <th valign="top" scope="row" class="label">
     <span class="alignleft"><?php echo _e("Canvas Size"); ?></span>
    </th>
    <td>
     <input type="text" name="canvas_width" size="10" value="<?php echo get_option('shipainter_defwidth'); ?>" style="width:100px;"/>
     (w)&nbsp;x&nbsp;
     <input type="text" name="canvas_height" size="10" value="<?php echo get_option('shipainter_defheight'); ?>" style="width:100px;"/>
     (h)
    </td>
   </tr>
   <tr>
    <th valign="top" scope="row" class="label">
     <span class="alignleft"><?php echo _e("Title"); ?></span>
    </th>
    <td>
     <input type="text" name="image_title" size="10" maxlength="64" value="paint"/>
    </td>
   </tr>
  </tbody></table>
 </div>
  <p class="submit">
   <input type="submit" name="submit" value="<?php _e('Exec Shi-Painter'); ?>" />
  </p>
 <input type="hidden" name="sp_mode" value="exec" />
 <input type="hidden" name="post_id" id="post_id" value="<?php echo $post_id; ?>" />
 <input type="hidden" name="type" value="<?php echo $GLOBALS['type']; ?>" />
 <input type="hidden" name="tab" value="<?php echo $GLOBALS['tab']; ?>" />
 <script type="text/javascript">
  <!--
   document.write('<input type="hidden" name="frame_id" value="');
   document.write(top.document.getElementById('TB_iframeContent').name);
   document.write('" />');
  // -->
 </script>
</form>
<?php
}

function shi_painter_conf()
{
    if(isset($_POST['submit'])){
        update_option('shipainter_tooltype',
                      ($_POST['shipainter_tooltype'] != 'std')? 'smp': 'std');
    }

    if('std' == get_option('shipainter_tooltype')){
        $stdsel = ' selected="yes"';
        $smpsel = '';
    }
    else {
        $smpsel = ' selected="yes"';
        $stdsel = '';
    }
    ?><div class="wrap">
<?php if(!has_shi_painter()){ ?><div class="error"><?php _e("NOT INSTALL Shi-Painter APPLET"); ?></div><?php } ?>
<h2><?php _e('Oekaki Shi-Painter Configuration'); ?></h2>
 <div>
  <form method="post" action="options-general.php?page=shi-painter-config">
   <table class="form-table">
    <tr valien="top"><th scope="row">Interface mode</th>
    <td><select name="shipainter_tooltype" id="shipainter_tooltype">
     <option value='smp'<?php echo $smpsel; ?>>simple mode</option>
     <option value='std'<?php echo $stdsel; ?>>pro mode</option>
    </select></td></tr>
   </table>
   <p class="submit">
    <input type="submit" name="submit" value="<?php _e('Save Changes'); ?>" />
   </p>
  </form>
 </div>
</div><?php
}
?>
